package conversions;

import session.ConversionsRemote;
import java.awt.*;
import java.awt.event.*;
import java.text.*;
import javax.ejb.EJB;
import javax.swing.*;

public class Client extends JFrame implements ActionListener {
   private Formater euro = new Formater(NumberFormat.getCurrencyInstance());
   private Formater franc = new Formater(new DecimalFormat("#,##0.00 F"));
   @EJB
   private static ConversionsRemote conversion;

    public Client() {
        super("Conversions");
        add(euro, BorderLayout.NORTH);
        add(franc, BorderLayout.SOUTH);
        pack();
        addWindowListener(new WindowAdapter() {
            @Override
            public void windowClosing(WindowEvent e) {  conversion.fin();  }
        });
        setResizable(false);
        setDefaultCloseOperation(EXIT_ON_CLOSE);
        setLocationByPlatform(true);
        setVisible(true);
    }

   public void actionPerformed(ActionEvent e) {
       if (e.getSource()==euro) {
          Number valeur = (Number) euro.getValue();
          franc.setValue(conversion.euroFranc(valeur.doubleValue()));
       }
       else {
          Number valeur = (Number) franc.getValue();
          euro.setValue(conversion.francEuro(valeur.doubleValue()));
       }
   }
  
   public static void main(String[] args) { new Client(); }
    
   private class Formater extends JFormattedTextField {
       Formater(NumberFormat format) {
           super(format);
           setHorizontalAlignment(RIGHT);
           setColumns(18);
           setValue(0.0);
           addActionListener(Client.this);
       }
   }
}
