package entite;

import java.io.Serializable;
import java.text.MessageFormat;
import java.util.*;
import javax.persistence.*;

@Entity
@NamedQuery(name="tousLesCalculs", query="SELECT calculs FROM Calculs AS calculs")
public class Calculs implements Serializable {
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private long id;

    @Temporal(javax.persistence.TemporalType.TIMESTAMP)
    private Date début;

    @Temporal(javax.persistence.TemporalType.TIMESTAMP)
    private Date fin;

    @ElementCollection
    private List<String> traitement = new ArrayList<String>();

    @OneToMany(cascade=CascadeType.ALL)
    @JoinColumn
    private List<Calcul> liste = new ArrayList<Calcul>();

    public long getId() { return id; }
    public Date getDébut() { return début; }
    public Date getFin() { return fin; }
    public List<String> getTraitement() { return traitement; }
    public List<Calcul> getListe() { return liste;  }

    public Calculs() { début = new Date(); }

    public void ajoutCalcul(double euro, double franc, char sens) {
        String motif = sens=='F' ? 
                               "{0, number, currency} --> {1, number, #,##0.00 F}" :
                               "{1, number, #,##0.00 F} --> {0, number, currency}";
        traitement.add(MessageFormat.format(motif, euro, franc));
        liste.add(new Calcul(euro, franc, sens));
        fin = new Date();
    }
}
