package session;

import entite.Calculs;
import java.util.List;
import javax.annotation.PostConstruct;
import javax.ejb.*;
import javax.persistence.*;

@Stateful
@LocalBean
public class Conversions implements ConversionsRemote {
    private final double TAUX = 6.55957;
    private Calculs calculs = new Calculs();
    @PersistenceContext
    EntityManager persistance;
    @EJB private  Scrutation scruter;

    @PostConstruct
    public void démarrer() {
       scruter.démarrer();
    }
    
    public double euroFranc(double euro) {
        double franc = euro * TAUX;
        enregistrerCalcul(euro, franc, 'F');
        return franc;
    }

    public double francEuro(double franc) {
        double euro = franc / TAUX;
        enregistrerCalcul(euro, franc, '€');
        return euro;
    }

    @Asynchronous
    private void enregistrerCalcul(double euro, double franc, char sens) {
        calculs.ajoutCalcul(euro, franc, sens);       
        if (persistance.find(Calculs.class, calculs.getId()) != null) persistance.merge(calculs);
        else persistance.persist(calculs);
    }

    public List<Calculs> getListeCalculs() {
        return persistance.createNamedQuery("tousLesCalculs").getResultList();
    }

    @Remove
    public void fin() {
        scruter.fin();
    }
}
